var fs = require("fs");
var Compiler = require('./lib/compiler');
var path = require("path");

    var c = fs.readFileSync("tahoe.json");
    var cfg = JSON.parse(c);
    var compiler = new Compiler(cfg);

    var expressInit = function(app) {
        var p = path.join(fs.realpathSync("."), cfg.tahoe.destDir, cfg.tahoe.name+"-schema");
        var tmpl = require(p);
        var view = app.get('view');
        view.prototype.lookup = function(path){
            return path.substring(0, path.lastIndexOf('.'));
        };
        app.set('view engine', 'xml');
        app.engine('xml',function(path, options, fn) {
            try {
                var p = path.split(":");
                var s = tmpl.renderSync(p[0], p[1], options);
                fn(null, s);
            } catch (e) {
                console.log(e.stack);
            }
        });
    };

module.exports = {
    config: cfg.tahoe,
    compiler: compiler,
    express: expressInit
};
