var fs = require("fs");
var path = require("path");
var varRegex = new RegExp("\\${[^}]+}");
var recursive = require('recursive-readdir');

var resolveEl = function(s, data) {
    if (!data) return s;
    var r;
    while ((r = varRegex.exec(s)) != null) {
        for (var i = 0; i < r.length; i++) {
            var exp = r[i];
            if (exp.substring(0, 2) === "${" && exp.substring(exp.length-1, exp.length) === "}") {
                var rep = eval("data." + exp.substring(2, exp.length - 1) + "");
                s = s.replace(exp, rep);
            }
        }
    }
    return s;
};

var buildCSS = function(cfg, data, cb) {
//    var files = Finder.from(opts.path).findFiles('component\\*.*');
    var s = {
        css:"",
        themes:[]
    };
    var count = cfg.tahoe.sourceDirs.length;
    cfg.tahoe.sourceDirs.forEach(function(d) {
        recursive(d, function (err, files) {
            files.map(function (f) {
                if (f.indexOf(".css", f.length - 4) == -1) return;
                var css = fs.readFileSync(f, "UTF-8");
                css = "/* sv:" + f + " */\n" + css;
                var baseName = path.basename(f);
                var thIndex = baseName.indexOf("theme-");
                if (thIndex == 0) {
                    var themeName = baseName.substr(thIndex, baseName.length -4);
                    if (!s.themes[themeName]) s.themes[themeName] ="";
                    s.themes[themeName] += css;
                } else {
                    s.css += resolveEl(css, data);
                }

            });
            count--;
            if (count == 0) cb(s);
        });
    });
};

module.exports = buildCSS;