var util = require("util");
var exp = require("../expression");
var AbstractTag = require("./abstractTag");
var Macro = function() {};
module.exports = Macro;
util.inherits(Macro, AbstractTag);

Macro.prototype.start = function() {
    this.body = new this.Body();
    this.name = this.node.attributes['name'];
    this.el = {};
    this.ctx.schema[this.name] = this.el;
    if (this.node.attributes['parent']) this.el.parent = this.node.attributes['parent'];
    this.isDef = true;
};

Macro.prototype.text = function(text) {
    this.body.write('ctx.write('+exp.resolveStr(text, "'")+');');
};

Macro.prototype.end = function() {
    if (!this.el.parent) {
        this.el.body = this.evalFunc(this.body.s);
    } else if (!this.defs && this.body.s.length > 0) {
        this.el.def = this.evalFunc(this.body.s);
    }

    if (this.defs) {
        for (var d in this.defs) {
            this.el[d] = this.evalFunc(this.defs[d]);
        }
    }
};