var Ctx = {};
Ctx.write = function (txt) {
    Ctx.body.write(txt);
};
Ctx.getBlock = function (name) {
    var ref = Ctx.schema;
    var ref1 = ref;
    var p = name.split(".");
    var n = "";
    for (var p1 = 0; p1 < p.length; p1++) {
        ref1 = ref;
        n = p[p1];
        ref = ref[n];
    }
    if (!ref) console.log("Could not find " + name);
    if (!ref.class) {
        ref = Ctx.init(ref);
        ref1[n] = ref;
    }
    return ref;
};
Ctx.init = function (block) {
    var a = function () {};
    if (block.parent) {
        a.prototype = Object.create(Ctx.getBlock(block.parent).class.prototype);
    } else {
        a.prototype.parent = function (block, name, ctx) {
            Ctx.getBlock(block).class.prototype[name](ctx);
        };
        a.prototype.write = Ctx.write;
        a.prototype.init = Ctx.init;
        a.prototype.getBlock = Ctx.getBlock;
    }
    for (var f in block)
        if (typeof block[f] === "function") {
            a.prototype[f] = block[f];
        }
    var a1 = new a();
    a1.class = a;
    return a1;
};
Ctx.body = "";
Ctx.write = function (str) {
    Ctx.body += str + "\n";
};
Ctx.renderSync = function (file, name, data) {
    Ctx.body = "";
    file = file.replace(/\\/g, "/");
    name = file + ":" + name;
    Ctx.getBlock(name).body(data);
    return ctx.body;
};
Ctx.render = function (file, name, data, cb) {
    cb(null, Ctx.renderSync(file, name, data));
};

module.exports = Ctx;
Ctx.schema = { "var:var":{ body:function (attrs) {var self = this;
this.write((attrs.x));
} },
  "var:parent_test":{ parent:"var:var",
    def:function (attrs) {var self = this;
} },
  "var:_anon_def_test":{ def:function (attrs) {},
    body:function (attrs) {var self = this;
this.def(attrs);
} },
  "var:anon_def_test":{ parent:"var:_anon_def_test",
    def:function (attrs) {var self = this;
this.write((attrs.x));
} },
  "var:_call_parent":{ def:function (attrs) {this.write('parent');
},
    body:function (attrs) {var self = this;
this.def(attrs);
} },
  "var:call_parent":{ parent:"var:_call_parent",
    def:function (attrs) {var self = this;
this.parent('var:_call_parent','def', attrs);
} },
  "var:__context_":{ def:function (attrs) {},
    body:function (attrs) {var self = this;
this.write('0-open '+(attrs.x));
this.def(attrs);
this.write('0-close '+(attrs.x));
} },
  "var:_context":{ def:function (attrs) {},
    body:function (attrs) {var self = this;
this.write('1-open '+(attrs.x));
this.def(attrs);
this.write('1-close '+(attrs.x));
} },
  "var:_context_":{ parent:"var:__context_",
    def:function (attrs) {var self = this;
this.init({parent: 'var:_context',def: function() {this.write('2-open '+(attrs.x));
self.def_1(attrs);
this.write('2-close '+(attrs.x));
},def_1: function() {self.def_1()},}).body({});
} },
  "var:context":{ parent:"var:_context_",
    def_1:function (attrs) {this.write('in '+(attrs.x));
} },
  "anon/anon:A":{ body:function (attrs) {var self = this;
this.write((attrs.x));
} },
  "anon/anon:B":{ body:function (attrs) {var self = this;
this.getBlock('anon/anon:A').body({x:(attrs.x),});
} },
  "anon/cascade-named:A":{ def_1:function (attrs) {},
    body:function (attrs) {var self = this;
this.write('a');
this.def_1(attrs);
this.write('a');
} },
  "anon/cascade-named:B":{ body:function (attrs) {var self = this;
this.write('b');
this.init({parent: 'anon/cascade-named:A',def: function() {self.def_1(attrs);
},def_1: function() {self.def_1()},}).body({});
this.write('b');
} },
  "anon/cascade-named:C":{ body:function (attrs) {var self = this;
this.write('c');
this.init({parent: 'anon/cascade-named:B',def: function() {self.def_1(attrs);
},def_1: function() {self.def_1()},}).body({});
this.write('c');
} },
  "anon/cascade-named:D":{ body:function (attrs) {var self = this;
this.write('d');
self.class.prototype.def_1=function() {this.write('hello');
};
this.init({parent: 'anon/cascade-named:C',def: function() {self.def_1(attrs);
},def_1: function() {self.def_1()},}).body({});
this.write('d');
} },
  "anon/cascade:A":{ def:function (attrs) {},
    body:function (attrs) {var self = this;
this.write('a');
this.def(attrs);
this.write('a');
} },
  "anon/cascade:B":{ body:function (attrs) {var self = this;
this.write('b');
this.init({parent: 'anon/cascade:A',def: function() {self.def(attrs);
},def: function() {self.def()},}).body({});
this.write('b');
} },
  "anon/cascade:C":{ body:function (attrs) {var self = this;
this.write('c');
this.init({parent: 'anon/cascade:B',def: function() {self.def(attrs);
},def: function() {self.def()},}).body({});
this.write('c');
} },
  "anon/cascade:D":{ body:function (attrs) {var self = this;
this.write('d');
this.init({parent: 'anon/cascade:C',def: function() {this.write('hello');
},}).body({});
this.write('d');
} },
  "inheritance/multi:A":{ def:function (attrs) {},
    body:function (attrs) {var self = this;
this.def(attrs);
} },
  "inheritance/multi:B":{ parent:"inheritance/multi:A",
    def:function (attrs) {var self = this;
this.write('hello from B');
} },
  "inheritance/multi:C":{ parent:"inheritance/multi:B",
    def:function (attrs) {var self = this;
this.write('hello from C');
} },
  "inheritance/cascade:A":{ def_a:function (attrs) {},
    body:function (attrs) {var self = this;
this.write('a1');
this.def_a(attrs);
this.write('a2');
} },
  "inheritance/cascade:B":{ parent:"inheritance/cascade:A",
    def_a:function (attrs) {this.write('b1');
this.def_b(attrs);
this.write('b2');
} },
  "inheritance/cascade:C":{ parent:"inheritance/cascade:B",
    def_b:function (attrs) {this.write('b in C');
} },
  "inheritance/named-defs:A":{ def_a:function (attrs) {},
    def_b:function (attrs) {},
    body:function (attrs) {var self = this;
this.def_a(attrs);
this.def_b(attrs);
} },
  "inheritance/named-defs:B":{ parent:"inheritance/named-defs:A",
    def_a:function (attrs) {this.write('a in B');
},
    def_b:function (attrs) {this.write('b in B');
} },
  "inheritance/named-defs:C":{ parent:"inheritance/named-defs:B",
    def_a:function (attrs) {this.write('a in C');
},
    def_b:function (attrs) {this.write('b in C');
} },
  "inheritance/simple:A":{ def:function (attrs) {},
    body:function (attrs) {var self = this;
this.def(attrs);
} },
  "inheritance/simple:B":{ parent:"inheritance/simple:A",
    def:function (attrs) {var self = this;
this.write('hello');
} } }